#! /usr/bin/sh -x
# generate a "cross-shaped" cubic surface map texture
# from 1K output images generated by gaseous-giganticus default values
#

# 1st row (north pole)
convert \
    xc:black -scale 1024x1024 \
    gasgiant-2.png \
    xc:black -scale 1024x1024 \
    xc:black -scale 1024x1024 \
    +append \
    row1.png
#2nd row (all around the equator)
convert \
    -strip \
    -rotate 180 \
    gasgiant-5.png \
    t5.png
convert \
    -strip \
    -rotate 0 \
    gasgiant-4.png \
    t4.png
convert \
    -strip \
    -rotate 90 \
    gasgiant-3.png \
    t3.png
convert \
    -strip \
    -rotate -90 \
    gasgiant-1.png \
    t1.png

# reorder so edges match
convert t1.png t5.png t3.png t4.png \
    +append \
    row2.png

# 3rd row (the south pole)
convert \
    xc:black -scale 1024x1024 \
    gasgiant-0.png \
    xc:black -scale 1024x1024 \
    xc:black -scale 1024x1024 \
    +append \
    row3.png

# the full map
convert \
    row1.png row2.png row3.png \
    -append \
    cube.png
